﻿using Microsoft.Win32.SafeHandles;
using System;
using System.Runtime.InteropServices;

class Program
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct TESTATTR
    {
        public int Age;
        public IntPtr Dummy;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct SECURITY_ATTRIBUTES
    {
        public uint nLength;
        public IntPtr lpSecurityDescriptor;
        public bool bInheritHandle;
    }

    [DllImport("kernel32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
    internal static unsafe extern SafeWaitHandle CreateEvent(SECURITY_ATTRIBUTES lpSecurityAttributes, bool isManualReset, bool initialState, string name);


    [DllImport("Win32Project1.dll", SetLastError = true, CharSet = CharSet.Auto)]
    static extern void fnWin32Project1(TESTATTR attr);

    static unsafe void Main(string[] args)
    {
        //SECURITY_ATTRIBUTES sa = new SECURITY_ATTRIBUTES();
        //SafeWaitHandle swh = CreateEvent(sa, true, false, "TEST_EVENT");
        
        TESTATTR testAttr = new TESTATTR();

        testAttr.Age = 2;
        testAttr.Dummy = new IntPtr(5);

        fnWin32Project1(testAttr);

        Console.WriteLine(string.Format("C#: {0}, {1}", testAttr.Age, testAttr.Dummy));
    }
}